/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*   (C) Copyright 1989, Bit Bucket Software Co., a Delaware Corporation.   */
/*                                                                          */
/*                                                                          */
/*                        MODEM7 file name receiver                         */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.230.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:132/101, 1:132/491, 1:141/491  */
/* 427-3 Amherst Street           AlterNet 7:491/0                          */
/* CS2032, Suite 232              BBS-Net  86:2030/1                        */
/* Nashua, NH 03061               Internet f491.n132.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*                                                                          */
/*  This module is based largely on a similar module in OPUS-CBCS V1.03b.   */
/*  The original work is (C) Copyright 1987, Wynn Wagner III. The original  */
/*  author has graciously allowed us to use his code in this work.          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <conio.h>

#ifdef __TURBOC__
#include <mem.h>
#else
#include <memory.h>
#endif

#include "com.h"
#include "xfer.h"
#include "zmodem.h"
#include "keybd.h"
#include "sbuf.h"
#include "sched.h"
#include "externs.h"
#include "prototyp.h"

/* ------------------------------------------------------------------------ */
/* TeLink batch mode file name mini-header                                  */
/* ------------------------------------------------------------------------ */
int recvmdm7 (fname)
char *fname;
{
   REGISTER int i, j;
   int got_dot;
   int retbyte;
   int tries;
   int xchksum;
   int got_eot;
   char *stat = NOTHING_msg;
   char tempname[30];

   XON_DISABLE ();                               /* ww */

   tries = got_eot = 0;

   if (PEEKBYTE () == (int) 0xffff)
      SENDBYTE (NAK);


top:

/* message (NULL);*/

   i = got_dot = 0;
   tries++;

   memset (tempname, '\0', 30);
   memset (fname, '\0', 30);

   while ((CARRIER()) && (tries < 8))
      {
      switch (retbyte = TIMED_READ (3))
         {
         case SUB:
            /*--------------------------------------------*/
            /* SUB                                        */
            /*--------------------------------------------*/
            if (!i)
               {
               if (tries < 4)
                  goto top;
               else
                  {
                  return (0);
                  }
               }

            for (xchksum = SUB, i = 0; tempname[i]; i++)
               xchksum += tempname[i];
            CLEAR_INBOUND ();
            SENDBYTE ((unsigned char) (xchksum & 0xff));
            retbyte = TIMED_READ (5);
            if (retbyte == ACK)
               {
               /*---- Gussy up the name ---------------*/
               memset (fname, '\0', 30);
               for (
                    i = j = got_dot = 0;
                    ((tempname[i]) && (i < 30));
                    i++
                  )
                  {
                  if (tempname[i] == '.')
                     got_dot = 1;
                  else if ((i == 8) && (!got_dot))
                     fname[j++] = '.';
                  fname[j++] = tempname[i];
                  }

               /* force BBS_STATUS to overwrite line */
/*             message (NULL);*/
               return 1;
               }

            got_eot = 0;
            SENDBYTE (NAK);
            goto top;

         case 'u':                              /* Another error condition */
         case ACK:
            /*--------------------------------------------*/
            /* ACK                                        */
            /*--------------------------------------------*/
            goto top;

         case EOT:
            /*--------------------------------------------*/
            /* EOT                                        */
            /*--------------------------------------------*/
            stat = EOT_msg;
            SENDBYTE (ACK);
            if (got_eot > 2)
               return 0;

            got_eot++;
            goto top;

         case CAN:
            /*--------------------------------------------*/
            /* CAN                                        */
            /*--------------------------------------------*/
            stat = CAN_msg;
            goto fubar;

         default:
            /*--------------------------------------------*/
            /* Default                                    */
            /*--------------------------------------------*/
            if (retbyte < ' ')
               {
               if (got_eot > 2)
                  return 0;
               else got_eot++;

               CLEAR_INBOUND ();

               SENDBYTE (NAK);
               goto top;
               }
            if (i >= 30)
               {
               stat = _s_mdm7toolong;
               goto fubar;
               }
            if ((retbyte >= ' ') && (retbyte <= '~'))
               {
               tempname[i++] = (char) retbyte;
               putchar (retbyte);
               }
            SENDBYTE (ACK);
         }                                       /* switch */
      }                                          /* while */

fubar:

   if (tries >= 16)
      stat = FUBAR_msg;
   status_line (" %s", stat);   /*PLF Tue  10-31-1989  19:44:32 */

   return 0;
}                                                /* get batchname */

/* END OF FILE: recvmdm7.c */
